#!/bin/bash
#$1:FILEPATH $2:ROOT
if [ "$#" != "2" ]; then
  echo "usage: $0 <filepath> <root>"
  echo "example: $0 /Node/node /Node/.node"
  exit 1
fi


groupadd node_public
useradd -g node_public -s /bin/false node_public
usermod -G node_public node
mkdir -p /Node/apache_public/logs
mkdir -p /Node/apache_public/htdocs/xnl/
mkdir -p /Node/apache/htdocs/.Node/soap/xnl

#PERMISSIONS

#/Node/apache_public : node_public.node_public 700
chgrp -R node_public /Node/apache_public
chown -R node_public /Node/apache_public
chmod -R 700 /Node/apache_public

#/Node/node/ node.node_public 755
chown node $1 
chgrp node_public $1
chmod  755 $1

#/Node/node/xnl/ node.node_public 750 -R
chown -R node $1/xnl
chgrp -R node_public $1/xnl
chmod -R 750 $1/xnl

#/Node/.node node.node_public 750 -R
chown -R node $2
chgrp -R node_public $2
chmod -R 750 $2 


ln -s /Node/apache/libexec /Node/apache_public/
echo "<?

\$XNL_PATH=\"$1/xnl/\";
include( \"$2/xnl.php\" );

?>
" >/Node/apache_public/htdocs/xnl/index.php
echo "<?

\$do=51;
include( \"../../index.php\" );

?>
" >/Node/apache/htdocs/.Node/soap/xnl/index.php


#install XNL 
SKEL_PATH="$1/xnl"
if [ ! -d "$SKEL_PATH" ]; then
  mkdir "$1/xnl"
  ln -s "$2/xnl/gentics" "$1/xnl/gentics"
  mv "$2/xnl/demo" "$1/xnl/demo"

  echo "<?xml version='1.0' encoding=\"iso-8859-1\" ?>
<configuration>
	<packages>
		<package key=\"demo\" />
		<package key=\"gentics\" />
	</packages>
</configuration>
" >$1/xnl/config.xml

fi

mv /Node/tmp/nodectl /Node/bin
chgrp node /Node/bin/nodectl 
chown node /Node/bin/nodectl
chmod 750 /Node/bin/nodectl

/Node/bin/nodectl restart

echo "##############################################"
echo "# XNL is now installed.                      #"
echo "# Test on http://localhost:42080/?config=all #"
echo "##############################################"
rm -f $0
