<?






function isSupereditEnabled($obj_type, $global_only = false) {
 global $T_PAGE, $T_TEMPLATE, $FEATURE;

 if ( $obj_type == $T_PAGE) {
 if (!$FEATURE["superedit_page"] ) return false;
 } else if ( $obj_type == $T_TEMPLATE ) {
 if (!$FEATURE["superedit_template"] ) return false;
 } else {
 return false;
 }
 
 if ( $global_only ) {
 return true;
 }
 
 if (!isCapableOfContenteditable()) {
 return false;
 }

 if ( getBrowser() == BROWSER_Firefox ) {
 if ( !$FEATURE["firefox_superedit"] ) return false;

 
 if ( $obj_type == $T_TEMPLATE ) return false;
 }
 
 
 
 return true;
}


function createLiveEditMenu($tagMenu, $childableJSFunction) {
 global $FEATURE, $LIVEEDIT_CUSTOM_MENU, $NODE_LIVEEDIT_CUSTOM_MENU, $LIVEEDIT_SPECIAL_CHARACTERS, $NODE_ID;
 
 if ($FEATURE["javaparser"]) {
 $myMenu = Array(
 Array( "name"=>i18n("cn_tag_new"), "bold"=>true, "submenu"=>$tagMenu, "displayFunction" => $childableJSFunction ),
 );
 } else {
 $myMenu = Array();
 }

 
 if ($FEATURE["liveedit_contextmenu_firstlevel_tags"]) {
 $constructs = 
 get_constructlist($NODE_ID, true, 
 ' AND construct.id IN (' . sqlf_tl_num_list_feature($FEATURE["liveedit_contextmenu_firstlevel_tags"]) . ')');
 foreach ( $constructs as $constr ) {
 $myMenu[] = Array(
 "name"=>$constr["name"], 
 "icon"=>tag_icon($constr["icon"]), 
 "confirm"=>false,
 "onclick"=>"cn3_add_tag( cn3_text_range, ".$constr["id"].", 'top.main.list');"
 );
 }
 }

 
 if ($FEATURE["liveedit_stripwordpaste"] && canAccessJsClipboard()) {
 $myMenu = array_merge( $myMenu, Array(
 Array( "name"=>i18n("paste_without_format"), "onclick"=>"execClipboardPaste(true,cn3_text_range)", "confirm"=>false ),
 Array( "name"=>i18n("paste_with_format"), "onclick"=>"execClipboardPaste(false,cn3_text_range)", "confirm"=>false ),
 Array( "name"=>i18n("Copy"), "onclick"=>"cn3_range_execCommand('Copy');", "confirm"=>false )
 ));
 }

 $customMenu = is_array($NODE_LIVEEDIT_CUSTOM_MENU[$NODE_ID]) ? $NODE_LIVEEDIT_CUSTOM_MENU[$NODE_ID] : $LIVEEDIT_CUSTOM_MENU; 
 if ( is_array($customMenu) ) {
 
 while (list($key,$val) = each($customMenu)) {
 $customMenu[$key]["name"] = i18n($val["name"]);
 }
 
 $myMenu = array_merge( $myMenu, Array( Array( 'displayFunction' => $childableJSFunction ) ), $customMenu );
 }

 
 
 
 if (is_array($LIVEEDIT_SPECIAL_CHARACTERS)) {
 $nrSpecialChars = count($LIVEEDIT_SPECIAL_CHARACTERS);
 $nrSpecialCharsCols = round(sqrt($nrSpecialChars)) + 1;
 $currentSpecialCharCol = 1;
 
 
 $specialCharMenuName = "<table border=0 style=\"cursor: pointer;\"><tr>";
 
 foreach($LIVEEDIT_SPECIAL_CHARACTERS as $currentSpecialChar) { 
 $specialCharMenuName .= "<td align=center bgcolor=black onmouseout=\"this.style.backgroundColor='#000000';this.style.color='#FFFFFF';\" onmouseover=\"this.style.backgroundColor='#C0C0C0';this.style.color='#000000';";
 if (is_array($currentSpecialChar)) {
 $specialCharMenuName .= " selectedSpecialChar='".$currentSpecialChar[0]."';\" ";
 } else {
 $specialCharMenuName .= " selectedSpecialChar='".$currentSpecialChar."';\" ";
 }
 
 $specialCharMenuName .= " onmouseout=\"this.style.backgroundColor='black'; ";
 $specialCharMenuName .= " selectedSpecialChar='';\">";
 
 if (is_array($currentSpecialChar)) {
 $specialCharMenuName .= "&nbsp;".$currentSpecialChar[1]."&nbsp;</td>";
 } else {
 $specialCharMenuName .= "&nbsp;".$currentSpecialChar."&nbsp;</td>";
 }
 
 
 if($currentSpecialCharCol == $nrSpecialCharsCols) {
 $specialCharMenuName .= "</tr><tr>";
 $currentSpecialCharCol = 0;
 }
 
 $currentSpecialCharCol += 1;
 }
 $specialCharMenuName .= "</tr></table>";
 
 
 $specialCharMenu = Array(
 Array ("name"=>$specialCharMenuName, "confirm"=>false, "onclick"=>"cn3_range_pasteHTML(selectedSpecialChar);", "noHighlighting" => true)
 );
 
 
 $myMenu = array_merge( $myMenu, Array(
 Array( "name"=>i18n("special_chars"), "bold"=>false, "submenu"=>$specialCharMenu, "displayFunction"=> $myFunction) 
 ) );
 }

 return $myMenu;
}



class LiveEditParser {

 var $replaceSpaces = false;
 
 
 function LiveEditParser() {
 global $FEATURE;
 $this->replaceSpace = $FEATURE["replace_live_spaces"]; 
 }

 function parseIECode($code) {
 
 
 $parts = $this->_splitNodeTags($code);
 $parts = $this->_parseIEParts($parts);
 $_code = $this->_mergeParts($parts);
 return $_code;
 }

 function prepareIECode($code) {
 $parts = $this->_splitNodeTags($code);
 $parts = $this->_prepareIEParts($parts);
 return $this->_mergeParts($parts);
 }


 function _splitNodeTags($code) {
 global $TAG_PREFIX;
 
 
 $parts = array();
 $pos1 = $pos2 = 0;
 $lastpos = 0;
 
 while (!is_false($pos1 = strpos($code, "<$TAG_PREFIX ", $lastpos))) {
 $pos2 = strpos($code,">",$pos1);
 
 if ($lastpos < $pos1) {
 $parts[] = array("code"=>substr($code, $lastpos, $pos1 - $lastpos), "istag"=>false);
 }
 $parts[] = array("code"=>substr($code, $pos1, $pos2 - $pos1 + 1), "istag"=>true);
 
 $lastpos = $pos2 + 1;
 }
 
 if ($lastpos < strlen($code)) {
 $parts[] = array("code"=>substr($code, $lastpos), "istag"=>false);
 }
 return $parts;
 }
 
 function _splitDivTags($code) {

 }
 
 function _mergeParts($parts) {
 $code = "";
 foreach ($parts as $part) $code .= $part["code"];
 return $code;
 }
 
 function _prepareIEParts($parts) {
 $isLastTag = false;
 foreach ($parts as $key=>$part) {
 if ($part["istag"]) {
 $isLastTag = $part["istag"];
 } else {
 
 if ($isLastTag && $this->replaceSpace && substr($part["code"], 0, 1) == " ") {
 $part["code"] = "&nbsp;".substr($part["code"], 1);
 }
 }
 $parts[$key] = $part;
 }
 return $parts; 
 }

 function _parseIEParts($parts) {
 $isLastTag = false;
 foreach ($parts as $key=>$part) {
 if ($part["istag"]) {
 $isLastTag = $part["istag"];
 } else {
 
 if ($isLastTag && $this->replaceSpace && substr($part["code"], 0, 6) == "&nbsp;") {
 $part["code"] = " ".substr($part["code"], 6);
 }
 }
 $parts[$key] = $part;
 }
 return $parts;
 }
}

?>
